package com.circuitengine.model.Components;

import java.awt.Graphics;
/*AUTHORS:

- Kevin Stueve (2009-12-20): initial published version
#*****************************************************************************
#       Copyright (C) 2009 Kevin Stueve kstueve@uw.edu
#
#  Distributed under the terms of the GNU General Public License (GPL)
#                  http://www.gnu.org/licenses/
#*****************************************************************************
*/
public abstract class Meter extends ElectricComponent {
  public static int METER_SIZE = 30;

  public Meter(int x, int y) {
    super(x, y);
  }

  public void draw(Graphics g) {
    super.draw(g);
    int x1 = head.getX();
    int x2 = tail.getX();
    int y1 = head.getY();
    int y2 = tail.getY();
    double xm = (x1 + x2) / 2;
    double ym = (y1 + y2) / 2;
    g.drawString("Meter", (int) xm-15, (int) ym + 15);
  }
}
