package com.circuitengine.model.Components;

import java.awt.Graphics;

import com.circuitengine.model.TiePoint;

/*AUTHORS:

- Kevin Stueve (2009-12-20): initial published version
#*****************************************************************************
#       Copyright (C) 2009 Kevin Stueve kstueve@uw.edu
#
#  Distributed under the terms of the GNU General Public License (GPL)
#                  http://www.gnu.org/licenses/
#*****************************************************************************
*/
public final class Switch extends ElectricComponent{
  public boolean isOpen=true;
  public void flip(){
    isOpen = !isOpen;
  }
  public Switch(int x, int y){
    super(x,y);
  }
  public void draw(Graphics g) {
    super.draw(g);
    int x1=head.getX();
    int x2=tail.getX();
    int y1=head.getY();
    int y2=tail.getY();
    int rise = y2 - y1;
    int run = x2 - x1;
    int distanceSquared = (rise * rise + run * run);
    double divisor;
    double seperationRise, seperationRun;
    divisor = Math.sqrt(distanceSquared) / 35.0;
    if (distanceSquared < 35 * 35) {
        divisor = 1.0;
    }
    double middlex1 = x1 + run / 2.0 - run / 2.0 / divisor;
    double middley1 = y1 + rise / 2.0 - rise / 2.0 / divisor;
    double middlex2 = x2 - run / 2.0 + run / 2.0 / divisor;
    double middley2 = y2 - rise / 2.0 + rise / 2.0 / divisor;
    seperationRise = middley2 - middley1;
    seperationRun = middlex2 - middlex1;
    g.drawLine(x1, y1, (int) middlex1, (int) middley1);
    g.drawLine((int) middlex2, (int) middley2, x2, y2);
    if (!isOpen){
       g.drawLine((int) middlex1, (int) middley1, (int) middlex2,
               (int)middley2);
    }else{
      g.drawLine((int) middlex1, (int) middley1, (int) (middlex1 + seperationRun - seperationRise / 2.7),
                 (int) (middley1 + seperationRise + seperationRun / 2.5));
    }
    g.drawOval((int)middlex1-5, (int)middley1-5, 10, 10);
    g.drawOval((int)middlex2-5, (int)middley2-5, 10, 10);
  }
}
