package com.circuitengine.model;

import java.awt.Point;
import java.util.HashSet;

import com.circuitengine.model.Components.ElectricComponent;

/*AUTHORS:

- Kevin Stueve (2009-12-20): initial published version
#*****************************************************************************
#       Copyright (C) 2009 Kevin Stueve kstueve@uw.edu
#
#  Distributed under the terms of the GNU General Public License (GPL)
#                  http://www.gnu.org/licenses/
#*****************************************************************************
*/
public final class TiePoint {
  int x,y;
  public HashSet<TiePoint> myConnectedTo;
  public HashSet<ElectricComponent>in,out;
 public TiePoint(){
   myConnectedTo=new HashSet<TiePoint>();
   in=new HashSet<ElectricComponent>();
   out=new HashSet<ElectricComponent>();
 }
 public TiePoint(final int x,final int y){
   this();
   this.x=x;
   this.y=y;
 }
 public TiePoint(final TiePoint theTiePoint) {
   this();
   this.x=theTiePoint.getX();
   this.y=theTiePoint.getY();
 }
 public Point getPosition(){
   return new Point(x,y);
 }
 public int getX(){
   return x;
 }
 public void setX(final int x){
   this.x=x;
 }
 public int getY(){
   return y;
 }
 public void setY(final int y){
   this.y=y;
 }
 public boolean isConnectedTo(final TiePoint other){
   if (myConnectedTo.contains(other)){
     //System.out.println("connected 1");
   }
   return myConnectedTo.contains(other);
 }
 public boolean isConnectedToOrder2(final TiePoint other){
   HashSet<TiePoint> intersection = new HashSet<TiePoint>(other.myConnectedTo);
   intersection.retainAll(this.myConnectedTo);
   if (intersection.size()>0){
     //System.out.println("connected 2");
   }
   return intersection.size()>0;
 }
}
