package com.circuitengine.view;

import java.awt.Component;
import java.awt.FlowLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.BoxLayout;
import javax.swing.JButton;
import javax.swing.JLabel;
import javax.swing.JPanel;

/*AUTHORS:

- Kevin Stueve (2009-12-20): initial published version
#*****************************************************************************
#       Copyright (C) 2009 Kevin Stueve kstueve@uw.edu
#
#  Distributed under the terms of the GNU General Public License (GPL)
#                  http://www.gnu.org/licenses/
#*****************************************************************************
*/
public final class HintPanel extends JPanel{
  CircuitEnginePanel myParentCircuitEnginePanel;
  String hint="";
  public HintPanel(final CircuitEnginePanel theParentCircuitEnginePanel) {
    super();
    myParentCircuitEnginePanel = theParentCircuitEnginePanel;
    this.setLayout(new BoxLayout(this, BoxLayout.Y_AXIS));
  }
  public void startingHint(){
    hint = "starting";
    this.removeAll();
    
    JLabel label = new JLabel("Click: Create a new "+myParentCircuitEnginePanel.mySelectedButton.toLowerCase());
    label.setAlignmentX(Component.CENTER_ALIGNMENT);
    this.add(label);
    label = new JLabel("Right Click:");
    label.setAlignmentX(Component.CENTER_ALIGNMENT);
    this.add(label);
    label = new JLabel("Drag:");
    label.setAlignmentX(Component.CENTER_ALIGNMENT);
    this.add(label);
    //myParentCircuitEnginePanel.setDrawing(false);
    //myParentCircuitEnginePanel.setMoving(false);
    myParentCircuitEnginePanel.validate();
  }
  public void drawingHint(){
    hint="drawing";
    this.removeAll();
    
    //label.setAlignmentX(Component.CENTER_ALIGNMENT);
    //this.add(label);
    
    
    JPanel panel = new JPanel();
    panel.setLayout(new FlowLayout());
    panel.add(new JLabel("Click: Create a "+myParentCircuitEnginePanel.mySelectedButton.toLowerCase()));
    JButton b = new JButton("Cancel");
    b.addActionListener(new ActionListener(){
      public void actionPerformed(ActionEvent e) {
        myParentCircuitEnginePanel.setIsDrawing(false);
        startingHint();
        myParentCircuitEnginePanel.repaint();
      }
    });
    panel.add(b);
    this.add(panel);
    JLabel label= new JLabel("Right Click:");
    label.setAlignmentX(Component.CENTER_ALIGNMENT);
    this.add(label);
    label = new JLabel("Drag:");
    label.setAlignmentX(Component.CENTER_ALIGNMENT);
    this.add(label);
    myParentCircuitEnginePanel.validate();
  }
  public void nearTiePointHint(){
    hint ="tiepoint";
    this.removeAll();
    JLabel label = new JLabel("Click: Create a new "+myParentCircuitEnginePanel.mySelectedButton.toLowerCase());
    label.setAlignmentX(Component.CENTER_ALIGNMENT);
    this.add(label);
    label = new JLabel("Right Click: Tiepoint options");
    label.setAlignmentX(Component.CENTER_ALIGNMENT);
    this.add(label);
    label = new JLabel("Drag: Move tiepoint");
    label.setAlignmentX(Component.CENTER_ALIGNMENT);
    this.add(label);
    //myParentCircuitEnginePanel.setDrawing(false);
    //myParentCircuitEnginePanel.setMoving(false);
    myParentCircuitEnginePanel.validate();
  }
  public void nearSwitchHint(){
    hint="switch";
    this.removeAll();
    JLabel label = new JLabel("Click: Toggle switch");
    label.setAlignmentX(Component.CENTER_ALIGNMENT);
    this.add(label);
    label = new JLabel("Right Click: Component options");
    label.setAlignmentX(Component.CENTER_ALIGNMENT);
    this.add(label);
    label = new JLabel("Drag:");
    label.setAlignmentX(Component.CENTER_ALIGNMENT);
    this.add(label);
    //myParentCircuitEnginePanel.setDrawing(false);
    //myParentCircuitEnginePanel.setMoving(false);
    myParentCircuitEnginePanel.validate();
  }
  public void nearComponentHint(){
    hint="component";
    this.removeAll();
    JLabel label = new JLabel("Click: Create a new "+myParentCircuitEnginePanel.mySelectedButton.toLowerCase());
    label.setAlignmentX(Component.CENTER_ALIGNMENT);
    this.add(label);
    label = new JLabel("Right Click: Component options");
    label.setAlignmentX(Component.CENTER_ALIGNMENT);
    this.add(label);
    label = new JLabel("Drag: Move component");
    label.setAlignmentX(Component.CENTER_ALIGNMENT);
    this.add(label);
    //myParentCircuitEnginePanel.setDrawing(false);
    //myParentCircuitEnginePanel.setMoving(false);
    myParentCircuitEnginePanel.validate();
  }
  public void movingHint(){
    
  }
}
