package com.circuitengine.model.Components;

import java.awt.Graphics;
/*AUTHORS:

- Kevin Stueve (2009-12-20): initial published version
#*****************************************************************************
#       Copyright (C) 2009 Kevin Stueve kstueve@uw.edu
#
#  Distributed under the terms of the GNU General Public License (GPL)
#                  http://www.gnu.org/licenses/
#*****************************************************************************
*/
public final class Voltmeter extends Meter {
  public String voltageString="??? V";
  public Voltmeter(int x, int y){
    super(x,y);
    primary="voltage";
    primaryUnitSymbol="V";
  }
  public void draw(Graphics g) {
    super.draw(g);
    int x1=head.getX();
    int x2=tail.getX();
    int y1=head.getY();
    int y2=tail.getY();
    int rise = y2 - y1;
    int run = x2 - x1;
    double distance=Math.sqrt(rise*rise+run*run);
    double xm=(x1+x2)/2;
    double ym=(y1+y2)/2;
    if (distance>=2*METER_SIZE){
        g.drawLine(x1,y1,(int)(x1+run/2.0-METER_SIZE*run/distance),(int)(y1+rise/2-METER_SIZE*rise/distance));
        g.drawLine((int)(x2-run/2.0+METER_SIZE*run/distance),(int)(y2-rise/2.0+METER_SIZE*rise/distance),x2,y2);
        g.drawOval((int)(xm-METER_SIZE),(int)(ym-METER_SIZE),2*METER_SIZE,2*METER_SIZE);
        g.drawString("+",(int)(x1+run/2.0-(METER_SIZE+10)*run/distance-10*rise/distance),
                     (int)(y1+rise/2-(METER_SIZE+10)*rise/distance+10*run/distance));
    }else{
        g.drawOval((int)(xm-distance/2),(int)(ym-distance/2),(int)distance,(int)distance);
    }
  }
}
